// Functions used for debugging

#include <stdio.h>
#include "agents.h"
#include "intern.h"
#include "lowinterface.h"
#include "nana.h"

void printAgentInfo (void)
{
  int i;
  int stay, move, take, drop, pass, stay_conflict, move_conflict;
  stay = move = take = drop = pass = stay_conflict = move_conflict = 0;
  for (i=0 ; i<pmgGetAgentNumber() ; i++)
    if (isAlive(i))
      switch (pmgiGetAgentActiontype(i)){
      case STAY: stay++; break;
      case MOVE: move++; break;
      case TAKE: take++; break;
      case DROP: drop++; break;
      case PASS: pass++; break;
      case STAY_CONFLICT: stay_conflict++; break;
      case MOVE_CONFLICT: move_conflict++; break;
      default: I (0);
      }
  printf ("Not finished: print *all* info\ncycle=%d, STAY=%d, MOVE=%d, TAKE=%d, DROP=%d, PASS=%d, STAY_CONF=%d, MOVE_CONF=%d\n", pmgGetCycle(), stay, move, take, drop, pass, stay_conflict, move_conflict);
}

void printConflictsInfo (void)
{
  int i;
  VL (("Thread %d: ending cycle %d with %d conflicts:",
       getTSD()->id, pmgGetCycle(), getConflictsNumberPar()));
  for (i=0 ; i<getConflictsNumberPar() ; i++)
    VL ((" %dmv %dca,", getConflictItemsNumberPar(i), getConflictItemsNumberCAPar(i)));
  VL (("\n"));
}
