// This file provides miscellaneous functions

#include <stdio.h>
#include <stdlib.h>
#include "agents.h"  // needed by intern.h
#include "intern.h"  // for type checking only
#include "lowinterface.h"  // for getTSD() only

// return a random number from 0 to max-1 using the *global* seed
int globrand (int max)
{
  return ((unsigned int)rand_r (&_gSeed)) % max;
}

void abcerror (char *err, int size)
{
  fprintf (stderr, err, size);
  abort ();
}

// return 1 if (y,x) is in the domain of the thread, else return 0
int isInMyDomain (int y, int x)
{
  tsd_t *ptsd = getTSD();
  ICHECKCOORDS (y, x);
  return ((ptsd->ytop <= y) && (y < ptsd->ybot)
	  && (ptsd->xtop <= x) && (x < ptsd->xbot));
}
