// This file provides functions to deal with pthreads library
// TODO: replace the I with a better alternative
// TODO: func may be a static variable in this file, not as field in pv pointer
// TODO: to find a solution to not include agents.h and intern.h

#include <stdio.h>  // TODO: to remove it (used only for printf)
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>
#include <errno.h>
#include "agents.h"
#include "intern.h"
#include "lowinterface.h"
#include "nana.h"

static thdata_t *thdata;
static pthread_t *th_t;  // used to join the threads at the end of simulation
//static sem_t semcount, semth;  // semaphores used for syncThreads
static sem_t semth0[2], semthX[2];  // semaphores used for syncThreads
static pthread_key_t thkey;  // the key (unique) to the thread-specific data
static pthread_mutex_t mutMAg;
static pthread_mutex_t mutCAg;
static pthread_mutex_t mutDAg;
static pthread_mutex_t mutKAg;
static pthread_mutex_t mutAg;
static pthread_mutex_t mutnbAg;
static pthread_mutex_t mutEmptyAg;
static pthread_mutex_t mutRandomAg;
static pthread_mutex_t *mutEmptyResN;
static pthread_mutex_t *mutUnvisResN;
static pthread_mutex_t *mutTotalResL;
static pthread_mutex_t mutfrch;

void lockTotalResL (int type)
{
  I (type <= getResourceTypesNumber());
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutTotalResL[type]);
}

void unlockTotalResL (int type)
{
  I (type <= getResourceTypesNumber());
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutTotalResL[type]);
}

void lockEmptyResN (int type)
{
  I (type <= getResourceTypesNumber());
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutEmptyResN[type]);
}

void unlockEmptyResN (int type)
{
  I (type <= getResourceTypesNumber());
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutEmptyResN[type]);
}

void lockUnvisResN (int type)
{
  I (type <= getResourceTypesNumber());
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutUnvisResN[type]);
}

void unlockUnvisResN (int type)
{
  I (type <= getResourceTypesNumber());
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutUnvisResN[type]);
}

void lockEmptyAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutEmptyAg);
}

void unlockEmptyAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutEmptyAg);
}

void lockRandomAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutRandomAg);
}

void unlockRandomAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutRandomAg);
}

void lockMAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutMAg);
}

void unlockMAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutMAg);
}

void lockCAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutCAg);
}

void unlockCAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutCAg);
}

void lockDAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutDAg);
}

void unlockDAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutDAg);
}

void lockKAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutKAg);
}

void unlockKAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutKAg);
}

void lockAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutAg);
}

void unlockAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutAg);
}

void locknbAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutnbAg);
}

void unlocknbAgent (void)
{
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutnbAg);
}

void lockfrch (void)
{
  if (_nbThreads > 1)
    pthread_mutex_lock (&mutfrch);
}

void unlockfrch (void)
{
  if (_nbThreads > 1)
    pthread_mutex_unlock (&mutfrch);
}

// -----------------------------------------------------------------------

tsd_t *getTSD (void)
{
  tsd_t *ptsd = (tsd_t*)pthread_getspecific (thkey);
  I (ptsd);
  return ptsd;
}

// wrap the thread starting function (common to sproc too?)
// pv is internally a pointer to thdata_t
static void *thfunc (void *pv)
{
  int ret;
  tsd_t *pdata;
  thdata_t *p = (thdata_t*)pv;
  // allocate the thread-specific data
  pdata = malloc (sizeof (tsd_t));
  if (pdata == NULL)
    abcerror ("Cannot allocate %d bytes in thfunc.  Aborting.\n", sizeof (tsd_t));
//  printf ("Allocated on %p, thread %d\n", pdata, p->id);
  ret = pthread_setspecific (thkey, pdata);
  I (ret == 0);
  p->func (p->id);
  return NULL;
}

// destroy the data DATA associated to a key in the thread-specific data
static void keydestroy (void *data)
{
//  printf ("Destroyed on %p\n", data);
  free (data);
}

static void initMutexes (void)
{
  int i;
  pthread_mutex_init (&mutfrch, NULL); // NULL=fast mutex, with no check (portable)
  pthread_mutex_init (&mutnbAg, NULL); // NULL=fast mutex, with no check (portable)
  pthread_mutex_init (&mutAg, NULL);   // NULL=fast mutex, with no check (portable)
  pthread_mutex_init (&mutDAg, NULL);  // NULL=fast mutex, with no check (portable)
  pthread_mutex_init (&mutKAg, NULL);  // NULL=fast mutex, with no check (portable)
  pthread_mutex_init (&mutCAg, NULL);  // NULL=fast mutex, with no check (portable)
  pthread_mutex_init (&mutMAg, NULL);  // NULL=fast mutex, with no check (portable)
  pthread_mutex_init (&mutEmptyAg, NULL);
  pthread_mutex_init (&mutRandomAg, NULL);
  mutTotalResL = malloc (getResourceTypesNumber() * sizeof(pthread_mutex_t));
  mutEmptyResN = malloc (getResourceTypesNumber() * sizeof(pthread_mutex_t));
  mutUnvisResN = malloc (getResourceTypesNumber() * sizeof(pthread_mutex_t));
  if (!mutTotalResL || !mutEmptyResN || !mutUnvisResN)
    abcerror ("Cannot allocate %d bytes three times in initMutexes.  Aborting.\n", getResourceTypesNumber() * sizeof(pthread_mutex_t));
  for (i=0 ; i<getResourceTypesNumber() ; i++){
    pthread_mutex_init (&mutTotalResL[i], NULL);
    pthread_mutex_init (&mutEmptyResN[i], NULL);
    pthread_mutex_init (&mutUnvisResN[i], NULL);
  }
}

static void destroyMutexes (void)
{
  int i, ret;
  for (i=getResourceTypesNumber()-1 ; i>=0 ; i--){ // in inverse order (even if not necessary)
    ret = pthread_mutex_destroy (&mutUnvisResN[i]);
    I (ret == 0);
    ret = pthread_mutex_destroy (&mutEmptyResN[i]);
    I (ret == 0);
    ret = pthread_mutex_destroy (&mutTotalResL[i]);
    I (ret == 0);
  }
  free (mutTotalResL);
  free (mutEmptyResN);
  free (mutUnvisResN);
  ret = pthread_mutex_destroy (&mutRandomAg);
  I (ret == 0);
  ret = pthread_mutex_destroy (&mutEmptyAg);
  I (ret == 0);
  ret = pthread_mutex_destroy (&mutMAg);
  I (ret == 0);
  ret = pthread_mutex_destroy (&mutCAg);
  I (ret == 0);
  ret = pthread_mutex_destroy (&mutDAg);
  I (ret == 0);
  ret = pthread_mutex_destroy (&mutKAg);
  I (ret == 0);
  ret = pthread_mutex_destroy (&mutAg);
  I (ret == 0);
  ret = pthread_mutex_destroy (&mutnbAg);
  I (ret == 0);
  ret = pthread_mutex_destroy (&mutfrch);
  I (ret == 0);
  ret = sem_destroy (&semth0[0]);
  I (ret == 0);
  ret = sem_destroy (&semth0[1]);
  I (ret == 0);
  ret = sem_destroy (&semthX[0]);
  I (ret == 0);
  ret = sem_destroy (&semthX[1]);
  I (ret == 0);
}

// execute the func FUNC by exactly NBTH threads: create NBTH-1 threads
//   executing FUNC function and execute itself the same FUNC function.
//   The FUNC function is wrapped into another function, see above
void createThreads (int nbth, threadfunc_t *func)
{
  int i, ret, ret1, ret2, ret3, ret4;
  I (nbth >= 0);
  thdata = malloc (nbth * sizeof (thdata_t));
  th_t = malloc (nbth * sizeof (pthread_t));
  if ((thdata == NULL) || (th_t == NULL))
    abcerror ("Cannot allocate %d bytes twice in createThreads.  Aborting.\n", nbth * sizeof (thdata_t));
  // initialize the semaphores
/*   ret = sem_init (&semcount, 0, 1);  // 0 = shared only by threads */
/*   ret = sem_init (&semth, 0, 0); */
  ret1 = sem_init (&semth0[0], 0, 0);
  ret2 = sem_init (&semth0[1], 0, 0);
  ret3 = sem_init (&semthX[0], 0, 0);
  ret4 = sem_init (&semthX[1], 0, 0);
  if (ret1 || ret2 || ret3 || ret4)
    abcerror ("Error initialising semaphores in createThreads: errno=%d.  Aborting\n", errno);
  initMutexes ();
  for (i=0 ; i<nbth ; i++){
    thdata[i].func = func;
    thdata[i].id = i;
  }
  // create the keys for specific-thread data
  ret = pthread_key_create (&thkey, keydestroy);
  I (ret == 0);
  // _nbThreads must be set before starting any thread (used by waitThreads and thfunc)
  _nbThreads = nbth;
  // start parallel execution
  for (i=1 ; i<nbth ; i++){  // start with 1, because 0 is the father process
    // NB: th_t[i] may be set before the thread starts
    ret = pthread_create (&th_t[i], NULL, thfunc, &thdata[i]);  // attr==NULL
    if (ret){
      printf ("createThreads: error %d creating thread number %d.  Aborting\n", ret, i);
      abort ();
    }
  }
  VL (("%d threads created\n", nbth-1));
  th_t[0] = pthread_self ();
  thfunc (&thdata[0]);  // execute thfunc(), like all the other threads
  // wait for all the other threads
  VL (("waiting for the %d threads...\n", _nbThreads-1));
  for (i=1 ; i<_nbThreads ; i++){
    ret = pthread_join (th_t[i], NULL);
    I (ret == 0);
  }
  VL (("done\n"));
  //  pthread_key_delete (thkey);  we need to remove TSD for thread 0 first
  destroyMutexes ();
/*   ret = sem_destroy (&semcount); */
/*   I (ret == 0); */
/*   ret = sem_destroy (&semth); */
/*   I (ret == 0); */
  free (th_t);
  free (thdata);
}

// synchronize all the threads (_nbThreads threads)
// barrier implementation using semaphores
// version written by Stephane Vialle
void syncThreads (void)
{
  static int tabindex;
  int crt, i;
  if (_nbThreads > 1){
    crt = tabindex;
    if (getTSD()->id == 0){
      for (i=0 ; i<_nbThreads-1 ; i++)
	sem_wait (&semth0[crt]);
      tabindex = 1 - tabindex;
      for (i=0 ; i<_nbThreads-1 ; i++)
	sem_post (&semthX[crt]);
    }else{
      sem_post (&semth0[crt]);
      sem_wait (&semthX[crt]);
    }
  }
}

// my barrier implementation with a sync bug...
// the bug is that a thread can awake all the others, continue, enter again in this function and go through wait() before the others be scheduled to go through wait()
/* void syncThreads (void) */
/* { */
/*   static int thcount;  // shared by all the threads */
/*   int i, ret; */
/*   if (_nbThreads == 1) */
/*     return;  // in sequential there are no threads to synchronize */
/*   sem_wait (&semcount); */
/*   thcount++; */
/*   if (thcount < _nbThreads){  // if not the last thread */
/*     ret = sem_post (&semcount); */
/*     I (ret == 0); */
/*     VL (("%d before wait\n", getTSD()->id)); */
/*     sem_wait (&semth); */
/*     VL (("%d after wait\n", getTSD()->id)); */
/*   }else{                  // it is the last thread */
/*     thcount = 0; */
/*     ret = sem_post (&semcount); */
/*     I (ret == 0); */
/*     for (i=0 ; i<_nbThreads-1 ; i++){ */
/*       VL (("%d before post\n", getTSD()->id)); */
/*       sem_post (&semth);  // awake all the other threads */
/*       VL (("%d after post\n", getTSD()->id)); */
/*     } */
/*   } */
/* } */
